# Contributing

## Introduction

First, thank you for considering contributing to the Karafka ecosystem! It's people like you that make the open source community such a great community! 😊

We welcome any type of contribution, not only code. You can help with:
- **QA**: file bug reports, the more details you can give the better (e.g. screenshots with the console open)
- **Marketing**: writing blog posts, howto's, printing stickers, ...
- **Community**: presenting the project at meetups, organizing a dedicated meetup for the local community, ...
- **Code**: take a look at the [open issues](https://github.com/karafka/karafka/issues). Even if you can't write code, commenting on them, showing that you care about a given issue matters. It helps us triage them.

## Submitting code

Any code change should be submitted as a pull request. The description should explain what the code does and give steps to execute it. The pull request should also contain tests.

### Code review process

Each pull request must pass all the rspec specs and meet our quality requirements.

To check if everything is as it should be, we use [Coditsu](https://coditsu.io) that combines multiple linters and code analyzers for both code and documentation. Once you're done with your changes, submit a pull request.

### Contributing to Pro components

All of Karafka components are open-source. However, the `Pro` components are licenses under `LICENSE-COMM`.

By sending a pull request to the pro components, you are agreeing to transfer the copyright of your code to Maciej Mensfeld.

## Questions

If you have any questions, create an [issue](https://github.com/karafka/karafka/issues) (protip: do a quick search first to see if someone else didn't ask the same question before!).
You can also reach us at contact@karafka.io.
